<template>
  <div class="app-collection grouped">
    <div
      v-show="is_loading"
      class="loader"
    >
      <img
        :src="loading_image"
        class="loader__image"
        alt="loader"
      >
    </div>

    <header class="appup__header">
      <!-- @slot Use this slot for header -->
      <slot name="header"></slot>
    </header>

    <main class="appup__body container-fluid">
      <div
        v-for="(value, key) in data"
        :key="key"
        class="appup__item"
      >
        <div class="group-header">
          <!-- @slot Use this slot group_header for each item in response -->
          <slot name="group_header" :title="key"></slot>
        </div>

        <div
          v-for="item in value"
          :key="item.id"
          class="appup__item--inner"
        >
          <!-- @slot Use this slot body for each item in response -->
          <slot name="body" :item="item"></slot>
        </div>

         <!-- @slot Use this slot group_footer for each item in response -->
         <div class="group-footer">
          <slot name="group_footer"></slot>
         </div>
      </div>
    </main>

    <div
      v-show="load_more_type === 'loadMoreButton'"
      ref="loader_div"
      class="load-more text-center mt-2"
    >
      <!-- @slot Slot for load more buttom, shown only if load_more_type is 'loadMoreButton' -->
      <slot name="load_more_button"></slot>
    </div>

    <footer class="appup__footer">
      <!-- @slot Use this slot for footer -->
      <slot name="footer"></slot>
    </footer>
  </div>
</template>

<script>
import AppCollection from './appup-collection.vue'
/**
 * Appup Grouped component which can be used to display items in grid, accordion, table
 * @requires VueBootstrap
 * @requires appup-collection.vue
 */
export default {
  name: 'appup-collection-grouped',

  extends: AppCollection,

  props: {
    /**
     * @param {string} loading_image - Data from every request will be grouped with this key
     * Required
     */
    group_key: {
      type: String,
      required: true,
    },
  },

  methods: {
    /**
     * @function @async set_ajax - Overrides function from app-data.
     * Get data from API with url, method and params from props, groups it
     * and sets it to data. If response has no data - sets empty array to data
     */
    async set_ajax() {
      const data = await this.fetch_data(`${this.url}${this.appup_cursor}`, this.method, this.params)
      this.appup_cursor += 1

      this.original_data = data
      this.data = this.group_array(data)
      this.has_more()
    },

    /**
     * @function @async group_array - Group given array by group_key prop.
     * @param {array} arr - array to be grouped
     */
    group_array(arr) {
      if (!arr.length) return {}

      const data = [...arr]
      const grouped = {}

      data.forEach((el) => {
        const key = el[this.group_key]
        delete el[this.group_key]

        if (grouped[key]) {
          grouped[key].push(el)
        } else {
          grouped[key] = [el]
        }
      })

      return grouped
    },

    /**
     * @function add - add new grouped data to data, update original data with new values
     * @param {array} new_data - new data to be added
     * @public
     */
    add(new_data = []) {
      if (!new_data.length) return
      this.original_data = [...this.original_data, ...new_data]
      this.data = { ...this.data, ...this.group_array(new_data) }
    },
  },
}
</script>

<style scoped>
  .grouped .appup__body {
    display: flex;
    flex-wrap: wrap;
    padding: 10px;
  }

  .appup__item {
    display: flex;
    flex-wrap: wrap;
  }

  .grouped .appup__item--inner {
    width: 300px;
    margin-right: 5px;
    display: flex;
  }

  .group-header,
  .group-footer {
    width: 100%;
  }
</style>
